<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

$userdata = array();
$userdata = AuthenticateUser();

if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$forumdata = array();
$forumdata = LoadForum( $fid );

if ( trim( $fid ) == NULL || $forumdata["success"] == FALSE )
{
	header( "Location: all_forums.php" );
	die();
}

$profiledata = array();
$profiledata = LoadProfile( $userdata["userid"] );

$ok = EnterForum( $fid, $userdata, $forumdata, $profiledata );

GenerateHeader( "EverList - New Topic", TRUE, TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$subscribed = IsSubscribed( $profiledata, $forumdata["fid"] );

if ( $userdata["authstatus"] != 1 )
{
	print "<b>You must be logged-in to post on this listserv.</b>";
	print "<br /><br />";
	print "<a href=\"login.php\">Login</a>";
}
else if ( $forumdata["ispublic"] != 1 && $subscribed == FALSE )
{
	print "<b>You must be subscribed to post on this forum.</b>";
	print "<br /><br />";
	if ( $forumdata["subscriptionpolicy"] == 0 )
	{
		print "Sorry, this forum is currently closed to new subscriptions.";
	}
	else if ( $forumdata["subscriptionpolicy"] == 3 )
	{
		print "You must be invited to this forum before you can subscribe to it.";
	}
	else
	{
		print "<a href=\"subscribe.php?fid=" . $forumdata["fid"] . "\">Click HERE to Subscribe!</a>";
	}
}
else
{
	/* Before we allow the post, check against the hourly/daily post limits.  --Kris */
	$limitreached = CheckPostLimitReached( $forumdata, $userdata );
	
	if ( $limitreached == 1 )
	{
		print "You have reached the maximum number of hourly posts allowed on this forum.  Please try again later.";
	}
	else if ( $limitreached == 2 )
	{
		print "You have reached the maximum number of daily posts allowed on this forum.  Please try again tomorrow.";
	}
	else
	{
		/* Whew!  Everything passed!  Allow the new post.  --Kris */
		NewPost( NULL, $fid );
	}
}

GenerateFooter();
