<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

$userdata = array();
$userdata = AuthenticateUser();

if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

if ( $newtopic == 0 )
{
	$tid = $posttid;
	
	$topicdata = array();
	$topicdata = LoadTopic( $tid );
	
	if ( $topicdata["success"] == FALSE && $newtopic == 0 )
	{
		GenerateHeader( "EverList - Topic", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		print "ERROR!  " . $topicdata["errmsg"];
		
		GenerateFooter();
		die();
	}
	
	$fid = $topicdata["fid"];
	
	$forumdata = array();
	$forumdata = LoadForum( $fid );
}
else
{
	$forumdata = array();
	$forumdata = LoadForum( $fid );
}

if ( trim( $fid ) == NULL || $forumdata["success"] == FALSE )
{
	header( "Location: all_forums.php" );
	die();
}

$isadmin = CheckUserAdmin();

if ( $forumdata["isclosed"] == 1 || $forumdata["isclosed"] == 2 
	|| ( $forumdata["isclosed"] == 3 && $isadmin == FALSE ) 
	|| ( $forumdata["isclosed"] == 4 && $isadmin == FALSE ) )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b style=\"color: red\">";
	print "This forum is currently CLOSED to new posts.  Please contact the listserv administrator for further information.";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$profiledata = array();
$profiledata = LoadProfile( $userdata["userid"] );

$ok = EnterForum( $fid, $userdata, $forumdata, $profiledata );

$subscribed = IsSubscribed( $profiledata, $forumdata["fid"] );

if ( $userdata["authstatus"] != 1 )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b>You must be logged-in to post on this listserv.</b>";
	print "<br /><br />";
	print "<a href=\"login.php\">Login</a>";
	
	GenerateFooter();
	die();
}
else if ( $forumdata["ispublic"] != 1 && $subscribed == FALSE )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b>You must be subscribed to post on this forum.</b>";
	print "<br /><br />";
	if ( $forumdata["subscriptionpolicy"] == 0 )
	{
		print "Sorry, this forum is currently closed to new subscriptions.";
	}
	else if ( $forumdata["subscriptionpolicy"] == 3 )
	{
		print "You must be invited to this forum before you can subscribe to it.";
	}
	else
	{
		print "<a href=\"subscribe.php?fid=" . $forumdata["fid"] . "\">Click HERE to Subscribe!</a>";
	}
	
	GenerateFooter();
	die();
}
else
{
	/* Before we allow the post, check against the hourly/daily post limits.  --Kris */
	$limitreached = CheckPostLimitReached( $forumdata, $userdata );
	
	if ( $limitreached == 1 )
	{
		GenerateHeader( "EverList - Submission Error", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		print "You have reached the maximum number of hourly posts allowed on this forum.  Please try again later.";
		
		GenerateFooter();
		die();
	}
	else if ( $limitreached == 2 )
	{
		GenerateHeader( "EverList - Submission Error", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		print "You have reached the maximum number of daily posts allowed on this forum.  Please try again tomorrow.";
		
		GenerateFooter();
		die();
	}
	else
	{
		/* Ok, now let's validate the submission itself.  --Kris */
		if ( ( trim( $topicname ) == NULL || strlen( trim( $topicname ) ) < 2 ) && $newtopic == 1 )
		{
			GenerateHeader( "EverList - Submission Error", TRUE );
			$topdata = array();
			$topdata = GenerateTop( $userdata );
			
			print "Post subject must be at least 2 characters in length!  Please hit your browser's back button and correct the error.";
			
			GenerateFooter();
			die();
		}
		else if ( trim( $postbody ) == NULL || strlen( trim( $postbody ) ) < 2 )
		{
			GenerateHeader( "EverList - Submission Error", TRUE );
			$topdata = array();
			$topdata = GenerateTop( $userdata );
			
			print "Post body must be at least 2 characters in length!  Please hit your browser's back button and correct the error.";
			
			GenerateFooter();
			die();
		}
		else if ( strlen( $postbody ) > 204800 )
		{
			GenerateHeader( "EverList - Submission Error", TRUE );
			$topdata = array();
			$topdata = GenerateTop( $userdata );
			
			/* Just a stop-gap security measure.  Better safe than sorry.  --Kris */
			print "Post body cannot exceed 200 KB in length!  Please hit your browser's back button and correct the error.";
			
			GenerateFooter();
			die();
		}
		else if ( strlen( $topicname ) > 70 )
		{
			GenerateHeader( "EverList - Submission Error", TRUE );
			$topdata = array();
			$topdata = GenerateTop( $userdata );
			
			/* Anything more and it won't fit in 1024x768....  --Kris */
			print "Post subject cannot exceed 70 characters in length!  Please hit your browser's back button and correct the error.";
			
			GenerateFooter();
			die();
		}
		
		/* Whew!  Everything passed!  Allow the new post.  --Kris */
		$cur_time = time();
		
		$topicname = addslashes( trim( $topicname ) );
		$topicname = str_ireplace( "<", "&lt;", $topicname );
		$topicname = str_ireplace( ">", "&rt;", $topicname );
		
		/* Unless that topic already exists....  --Kris */
		$query = "select tname, tid, fid from topics where tname='$topicname'";
		$resulttl1b = mysql_query( $query ) or die( "Query '$query' failed for resulttl1b in submitpost.php : " . mysql_error() );
		
		$tname = NULL;
		while ( $line = mysql_fetch_array( $resulttl1b, MYSQL_ASSOC ) )
		{
			$sqloop = 0;
			foreach ( $line as $col_value )
			{
				$fieldname = mysql_field_name( $resulttl1b, $sqloop );
				$$fieldname = $col_value;
				$sqloop++;
			}
		}
		
		$cur_time = time();
		
		if ( trim( $tname ) != NULL && $newtopic != 0 )
		{
			GenerateHeader( "EverList - Submission Error", TRUE );
			$topdata = array();
			$topdata = GenerateTop( $userdata );
			
			print "<b>That topic ($subject) already exists on this or another forum!</b>";
			print "<br /><br />";
			print "<a href=\"javascript: history.go(-1);\">Back</a>";
			
			GenerateFooter();
			die();
		}

		/* Prevent hackers from posting harmful embeds & etc.  --Kris */
		$postbody = str_ireplace( "<script", "&lt;script", $postbody );
		$postbody = str_ireplace( "</script", "&lt;/script", $postbody );
		$postbody = str_ireplace( "<frame", "&lt;frame", $postbody );
		$postbody = str_ireplace( "<iframe", "&lt;iframe", $postbody );
		$postbody = str_ireplace( "<embed", "&lt;embed", $postbody );
		
		$postbody = addslashes( trim( $postbody ) );
		
		if ( $newtopic == 1 )
		{
			$query = "select tname from topics where tname='$topicname'";
			$resulttl6 = mysql_query( $query ) or die( "Query '$query' failed for resulttl6 in submitpost.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resulttl6, MYSQL_ASSOC ) )
			{
				$sqloop = 0;
				foreach ( $line as $col_value )
				{
					$fieldname = mysql_field_name( $resulttl6, $sqloop );
					$$fieldname = $col_value;
					$sqloop++;
				}
			}
			
			if ( strcasecmp( $topicname, $tname ) == 0 )
			{
				GenerateHeader( "EverList - Submission Error", TRUE );
				$topdata = array();
				$topdata = GenerateTop( $userdata );
				
				print "That topic name already exists!  Please hit your browser's back button and correct the error.";
				
				GenerateFooter();
				die();
			}
			
			$query = "insert into topics values ( NULL, '$fid', ";
			$query .= "'" . $userdata["userid"] . "', '$topicname', '$cur_time', ";
			$query .= "'$ipb', 'NEW' )";
			$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in submitpost.php : " . mysql_error() );
			
			$query = "select tid from topics where ttimestamp='$cur_time' AND createdbyuserid='" . $userdata["userid"] . "'";
			$resulttl2 = mysql_query( $query ) or die( "Query '$query' failed for resulttl2 in submitpost.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resulttl2, MYSQL_ASSOC ) )
			{
				$sqloop = 0;
				foreach ( $line as $col_value )
				{
					$fieldname = mysql_field_name( $resulttl2, $sqloop );
					$$fieldname = $col_value;
					$sqloop++;
				}
			}
			
			/* This should never happen!  --Kris */
			if ( $tid == NULL )
			{
				die( "ERROR!  Unable to determine tid for ttimestamp '$cur_time' and createdbyuserid '" . $userdata["userid"] . "'!  Please copy/paste this error into an email and send it to <a href=\"mailto: kris.craig@gmail.com\">Kris.Craig@gmail.com</a>!" );
			}
		}
		else
		{
			$query = "update topics set ttimestamp='$cur_time' where tid='$tid'";
			$resulttl5 = mysql_query( $query ) or die( "Query '$query' failed for resulttl5 in submitpost.php : " . mysql_error() );
		}
		
		$query = "insert into posts values ( NULL, '$tid', '" . $userdata["userid"] . "', ";
		$query .= "'$postbody', '$excludemessage', '$cur_time', '$cur_time', '$ipb', 'NEW' )";
		$resulttl3 = mysql_query( $query ) or die( "Query '$query' failed for resulttl3 in submitpost.php : " . mysql_error() );
		
		$query = "select pid from posts where ptimestamp='$cur_time' AND createdbyuserid='" . $userdata["userid"] . "'";
		$resulttl4 = mysql_query( $query ) or die( "Query '$query' failed for resulttl4 in submitpost.php : " . mysql_error() );
		
		while ( $line = mysql_fetch_array( $resulttl4, MYSQL_ASSOC ) )
		{
			$sqloop = 0;
			foreach ( $line as $col_value )
			{
				$fieldname = mysql_field_name( $resulttl4, $sqloop );
				$$fieldname = $col_value;
				$sqloop++;
			}
		}
		
		/* This should never happen!  --Kris */
		if ( $pid == NULL )
		{
			die( "ERROR!  Unable to determine pid for ptimestamp '$cur_time' and createdbyuserid '" . $userdata["userid"] . "'!  Please copy/paste this error into an email and send it to <a href=\"mailto: kris.craig@gmail.com\">Kris.Craig@gmail.com</a>!" );
		}
		
		/* Alrighty!  We're done!  Now let's redirect the user to the new post.  --Kris */
		header( "Location: viewtopic.php?tid=" . $tid . "&newpost=1#" . $pid );
	}
}
